:-style_check(-singleton).
:-ensure_loaded('/home/tkutsia/prholog/prholog-full/library.pl').

try(A, D, Q, S, T, V) :-
    solve([ [hdg_rholog_internal, ind_var(i_str)]<<[hdg_rholog_internal|A]
          ],
          B),
    instance([hdg_rholog_internal, seq_var(s_in)], B, C),
    solve([C<<D], E),
    ( my_append(B, E, F),
      instance([ind_var(i_str)], F, [G|I]),
      instance([hdg_rholog_internal, seq_var(s_in)], F, L),
      instance([hdg_rholog_internal, seq_var(s_out)], F, M),
      instance([], F, N),
      get_strategy_name_arguments_from_the_list_form(G, J, H),
      my_append(H, I, K),
      O=..[J, K, L, M, N, F, P],
      O
    ),
    instance([hdg_rholog_internal, seq_var(s_out)], P, R),
    solve([Q<<R|S], U),
    compose(T, U, V).

try(A, D, G, I, J, L) :-
    solve([[hdg_rholog_internal, i_]<<[hdg_rholog_internal|A]], B),
    instance([hdg_rholog_internal, seq_var(s_in)], B, C),
    solve([C<<D], E),
    my_append(B, E, F),
    instance([hdg_rholog_internal, seq_var(s_in)], F, H),
    solve([G<<H|I], K),
    compose(J, K, L).

try_one(A, D, Q, S, T, V) :-
    solve([ [hdg_rholog_internal, ind_var(i_str)]<<[hdg_rholog_internal|A]
          ],
          B),
    instance([hdg_rholog_internal, seq_var(s_X)], B, C),
    solve([C<<D], E),
    ( my_append(B, E, F),
      instance([first_one, ind_var(i_str), id], F, [G|I]),
      instance([hdg_rholog_internal, seq_var(s_X)], F, L),
      instance([hdg_rholog_internal, seq_var(s_Y)], F, M),
      instance([], F, N),
      get_strategy_name_arguments_from_the_list_form(G, J, H),
      my_append(H, I, K),
      O=..[J, K, L, M, N, F, P],
      O
    ),
    instance([hdg_rholog_internal, seq_var(s_Y)], P, R),
    solve([Q<<R|S], U),
    compose(T, U, V).

try_all(A, D, Q, S, T, V) :-
    solve([ [hdg_rholog_internal, ind_var(i_str)]<<[hdg_rholog_internal|A]
          ],
          B),
    instance([hdg_rholog_internal, seq_var(s_X)], B, C),
    solve([C<<D], E),
    ( my_append(B, E, F),
      instance([first_all, ind_var(i_str), id], F, [G|I]),
      instance([hdg_rholog_internal, seq_var(s_X)], F, L),
      instance([hdg_rholog_internal, seq_var(s_Y)], F, M),
      instance([], F, N),
      get_strategy_name_arguments_from_the_list_form(G, J, H),
      my_append(H, I, K),
      O=..[J, K, L, M, N, F, P],
      O
    ),
    instance([hdg_rholog_internal, seq_var(s_Y)], P, R),
    solve([Q<<R|S], U),
    compose(T, U, V).

strat(A, D, T, V, W, Y) :-
    solve([[hdg_rholog_internal]<<[hdg_rholog_internal|A]], B),
    instance([hdg_rholog_internal, ind_var(i_n)], B, C),
    solve([C<<D], E),
    ( ( my_append(B, E, F),
        instance([>, ind_var(i_n), 0], F, G),
        replace_rholog_ind_vars_by_prolog_vars(G, H),
        symbol_list_to_term(H, I),
        I,
        term_to_list(I, J),
        solve([G<<J], K),
        compose(F, K, L)
      ),
      my_append([], L, M),
      instance([is, ind_var(i_nsquare), [^, ind_var(i_n), 2]], M, N),
      replace_rholog_ind_vars_by_prolog_vars(N, O),
      symbol_list_to_term(O, P),
      P,
      term_to_list(P, Q),
      solve([N<<Q], R),
      compose(M, R, S)
    ),
    instance([hdg_rholog_internal, ind_var(i_nsquare)], S, U),
    solve([T<<U|V], X),
    compose(W, X, Y).

strat(A, D, G, I, J, L) :-
    solve([[hdg_rholog_internal]<<[hdg_rholog_internal|A]], B),
    instance([hdg_rholog_internal, 2], B, C),
    solve([C<<D], E),
    my_append(B, E, F),
    instance([hdg_rholog_internal, 22, 11], F, H),
    solve([G<<H|I], K),
    compose(J, K, L).


